package es.um.ejercicios.clases;

import es.um.ejercicios.interfaces.CambioColor;

public class VehiculoMotor extends Vehiculo implements CambioColor {

    public enum Combustible {
        GASOLINA, DIESEL, OTROS
    }

    private final int VELOCIDAD = 100;
    private Combustible combustible;
    private String modelo;
    private double co2Emitido;
    private String matricula;

    public Combustible getCombustible() {
        return combustible;
    }

    public void setCombustible( Combustible combustible ) {
        this.combustible = combustible;
    }

    public String getModelo() {
        return modelo;
    }

    public void setModelo( String modelo ) {
        this.modelo = modelo;
    }

    public double getCo2Emitido() {
        return co2Emitido;
    }

    public void setCo2Emitido( double co2Emitido ) {
        this.co2Emitido = co2Emitido;
    }

    @Override
    public void avanzaDistancia( int horas ) {
        super.setDistanciaRecorrida( horas * VELOCIDAD );
    }

    @Override
    public void cambiarColor( Color nuevoColor ) {
        this.setColorVehiculo( nuevoColor );
    }

    
    public String getMatricula() {
        return matricula;
    }

    
    public void setMatricula( String matricula ) {
        this.matricula = matricula;
    }

}
