package es.um.ejercicios.ejecutores;

import java.util.ArrayList;

import es.um.ejercicios.clases.Vehiculo;
import es.um.ejercicios.clases.Vehiculo.Color;
import es.um.ejercicios.clases.VehiculoMotor;
import es.um.ejercicios.clases.VehiculoSinMotor;
import es.um.ejercicios.interfaces.CambioColor;

public class Ejercicio3 {

    public static void main( String[] args ) {

        VehiculoMotor coche = new VehiculoMotor();
        coche.setCo2Emitido( 10.3 );
        coche.setColorVehiculo( Color.ROJO );
        coche.setFabricante( "Ford" );
        coche.setModelo( "Modeo" );
        coche.setNumeroRuedas( 4 );
        coche.setPlazas( 5 );
        coche.setValor( 25.000 );
        coche.setMatricula( "5566ABC" );

        VehiculoSinMotor bici = new VehiculoSinMotor();
        bici.setColorVehiculo( Color.AZUL );
        bici.setFabricante( "BH" );
        bici.setNumeroRuedas( 2 );
        bici.setPlazas( 1 );
        bici.setRequiereProtecciones( true );
        bici.setValor( 900 );

        coche.avanzaDistancia( 2 );
        bici.avanzaDistancia( 2 );
        System.out.println( "Distancia recorrida por " + coche.getMatricula() + " " + coche.getDistanciaRecorrida()+" km" );
        if ( bici instanceof VehiculoSinMotor ) {
            System.out.println( "Distancia recorrida por bicicleta: " + bici.getDistanciaRecorrida() +" km");
        }
        
        //Insertamos los objetos en una lista pese a se de tipos diferentes
        //Los insertamos como su clase padre
        ArrayList<Vehiculo> vehiculos = new ArrayList<Vehiculo>();
        vehiculos.add( coche );
        vehiculos.add( bici );
        
        //Cambiamos el color de los vehiculos sin necesidad de saber la clase exacta que son
        //Hacemos uso de la interfaz
        for(Vehiculo vehiculo: vehiculos){
            //con "instanceof" preguntamos el tipo de clase real del objeto
            if ( vehiculo instanceof VehiculoSinMotor ) {
                System.out.println( "Color vehiculo sin motor " + vehiculo.getColorVehiculo() );
            }
            if ( vehiculo instanceof VehiculoMotor ) {
                System.out.println( "Color vehiculo " + vehiculo.getColorVehiculo() );
            }
            //Hacemos un cast a la interfaz para acceder a sus metodos
            ((CambioColor)vehiculo).cambiarColor( Color.AMARILLO );
        }
        
        System.out.println( "Nuevo color coche " + coche.getColorVehiculo() );
        System.out.println( "Nuevo color bici " + bici.getColorVehiculo() );
        
        
    }
}
